/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.web.gwt.client.utils;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.StatusCodeException;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author CBO
 */
public class GWTUtils {

    static public final int REMOTE_ERROR_FOR_REDIRECTION_CODE = 1000;

    public static void handleRPCError(Throwable pThrowable) {
        try {
            throw pThrowable;
        } catch(StatusCodeException sce) {
            if (sce.getStatusCode() == GWTUtils.REMOTE_ERROR_FOR_REDIRECTION_CODE) {
                GWTUtils.setURL(sce.getMessage());
            } else {
                handleUnExpectedRPCError(pThrowable);
            }
        } catch(Throwable t) {
            handleUnExpectedRPCError(pThrowable);
        }
    }

    public static native void setURL(String url) /*-{
      $wnd.top.location.href = url;
    }-*/;

    public static native String getBrowserName() /*-{
      return BrowserDetect.browser;
    }-*/;

    public static native String getBrowserVersion() /*-{
      return BrowserDetect.version;
    }-*/;
    public static native String getClientOS() /*-{
      return BrowserDetect.OS;
    }-*/;
    private static void handleUnExpectedRPCError(Throwable throwable) {
        Window.alert("Erreur innatendue" + (throwable != null ? " : " + throwable.toString() : ""));
    }

    static public void hide(Widget widget) {
        DOM.setStyleAttribute(widget.getElement(), "visibility", "hidden");
    }

    static public String getContextPath() {
        return GWT.getModuleBaseURL().replace(GWT.getModuleName() + "/", "");
    }
}
